<?php
/* ************************* *
 * SQLite3 DB control class
 *************************** */
class SQLite extends SQLite3{
  function __construct($db_file,$readonly = false){
    if($readonly) $this->open($db_file,SQLITE3_OPEN_READONLY);
    else $this->open($db_file);
  }
  function _destroy(){
    $this->close();
  }
}

class kvmDB{
  var $_db,$_db_path;

  function kvmDB(){
    if(func_num_args() > 0){
      $arg_list = func_get_args();
      $this->_db_path = $arg_list[0];
      $readonly = ($arg_list[0] == $GLOBALS['_db_path_records']) ? true:false;
      unset($arg_list);
    }else{
      $this->_db_path = $GLOBALS['_db_path_settings'];
      $readonly = false;
    }
    $this->_db = new SQLite($this->_db_path,$readonly);
  }

  function __destruct(){
    if($this->_db) $this->_db->_destroy();
    unset($this->_db);
  }

  function getData($qry){
    return $this->_db->query($qry);
  }

  function getDataSingle($qry){
    return $this->_db->querysingle($qry);
  }

  function setData($qry){
    return $this->_db->exec($qry);
  }
}
?>