<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';
$kvmJson = new kvmJson();
$kvmDB = new kvmDB();
$input_pw = isset($_POST['password']) ? $_POST['password'] : "";
$input_pw = cryptPW($input_pw);
$super_pw = $kvmDB->getDataSingle("SELECT pw FROM users_data WHERE type='super'");
$error = false;
if($input_pw == $super_pw){
  if(!isset($_GET["callback"]) && isset($_SESSION['user_type']) && $_SESSION['user_type'] == "super"){

    //등록된 장비에 나 삭제 요청
    $ex_device_sql = "SELECT ip4,web_port FROM devices_data WHERE local = 'N' AND active = 'Y'";
    $rs = $kvmDB->getData($ex_device_sql);
    $is_ex_device = $kvmDB->getDataSingle($ex_device_sql);

    if($is_ex_device != ""){
      require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';

      $curl_data = "&seq=".$_local_device_seq."&send_device=".$_local_device_seq."&send_user=".$_SESSION['user_id']."&name=".$_local_device_name."&init=y";

      $curl = new CURL();
      $curl_opts = array(
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_CONNECTTIMEOUT => 5,
        CURLOPT_POSTFIELDS => $curl_data
      );
      $rs = $kvmDB->getData($ex_device_sql);

      while($row = $rs->fetchArray()){
        $curl->addSession("http://".$row['ip4'].":".$row['web_port']."/devices/delete.php", $curl_opts);
      }
      $curl->exec();
      $curl->clear();
      unset($crul,$curl_opts);
    }

    //log변환
    $logDB = new kvmDB($_db_path_logs);

    $rs = $logDB->getData("SELECT seq,location,target,user FROM logs_data WHERE past = 0");

    while($row = $rs->fetchArray(SQLITE3_ASSOC)){
      $data = outputLog($row);
      if($data["device"] != ""){
        $data["device"] = "#".$data["device"];
        $row['location'] = ($data["location"] == "") ? "" : substr($row["location"],0,strpos($row["location"],"#"));
      }
      if($data["target_type"] != "") $data["target_type"] .= "#";
      if($data["target_type"] == "LOCATION#") $data["target"] = substr($row["target"],strpos($row["target"],"#")+1);
      $sql = "UPDATE logs_data SET
                location = '".$row["location"].$data["device"]."',
                target = '".$data["target_type"].$data["target"]."',
                user = '".$data["user"]."',
                past = 1
              WHERE seq = '".$data["seq"]."'";
      $logDB->setData($sql);
    }
    unset($logDB);

    //db삭제후교체
    if(initDB("result") == true){
      forceSession();
    }else{
      //COPY ERROR
      $error = true;
      $log_code = "CODE_SETTING_023";
      $output_message = "ALERT_SETTING_023";
    }
  }
  else{
    //PERMITION ERROR
    $error = true;
    $log_code = "CODE_SETTING_022";
    $output_message = "ALERT_SETTING_022";
  }
}else{
  //PW ERROR
  $error = true;
  $log_code = "CODE_SETTING_024";
  $output_message = "ALERT_SETTING_024";
}
if($error == true){
  inputLog("WARNING", "L_SETTINGS", "LOCATION#L_SETTINGS_SYSTEM", "K_PROCESS", $_SESSION['user_seq'], $log_code, "");
  $kvmJson->setJsonData("fieldName", "");
   $kvmJson->setJsonData("statusText", msg($output_message));
   $kvmJson->setJsonData("statusType", "error");
   header("HTTP/1.0 500 Menual Error");
  echo $kvmJson->getJsonEncode();
}else{
  header("Content-type:text/javascript; charset=utf-8");
  echo "true";
}
unset($kvmJson,$kvmDB);
?>