<?php
  //session_start();

  require_once '_common.php';
  $_add_log_message = "";
  //이미 등록된 디바이스면 오류
  if($already_reg_device == "1"){
    $_add_log_message .= $device_name."(".$device_ip4.")";
    inputLog("WARNING", $_this_location, $device_name, "K_CREATE", $_this_user, "CODE_DEVICES_001", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_001"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }elseif($already_reg_device == "2"){
    //장비를 삭제하고 다시 등록함.
    $kvmDB->setData("DELETE FROM devices_data WHERE seq = '".$device_seq."'");
  }

  $sql = "INSERT INTO devices_data (
            seq, name, ip4, ip6, subnet4, subnet6, gateway4, gateway6, web_port, dns1, dns2, local, active, date, pending
          ) VALUES (
            '".$device_seq."', '".$device_name."',
            '".$device_ip4."', '".$device_ip6."',
            '".$device_subnet4."', '".$device_subnet6."',
            '".$device_gateway4."', '".$device_gateway6."',
            '".$device_webport."',
            '".$device_dns1."', '".$device_dns2."',
            'N', 'Y', DATETIME('NOW','localtime'),";

/* **************************** *
 * 로컬에서 외부 장비 추가
 *
 * **************************** */
  if($send_device == ""){
    //일반유저 작업불가
    if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){
      inputLog("WARNING", $_this_location, $device_name, "K_CREATE", $_this_user, "CODE_DEVICES_002", "");
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_002"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }
    //원격에 내 정보를 보내기
     $curl_data ="&name=".$this_device_name."&ip4=".$this_device_ip4."&ip6=".$this_device_ip6.
                "&subnet4=".$this_device_subnet4."&subnet6=".$this_device_subnet6.
                "&gateway4=".$this_device_gateway4."&gateway6=".$this_device_gateway6.
                "&web_port=".$this_device_web_port.
                "&dns1=".$this_device_default_dns."&dns2=".$this_device_sub_dns.
                "&seq=".$this_device_seq."&send_device=".$this_device_seq."&send_user=".$_SESSION['user_id'];
    $curl = new CURL();
    $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_POST => true,
      CURLOPT_CONNECTTIMEOUT => 5,
      CURLOPT_POSTFIELDS => $curl_data
    );
    $curl->addSession( "http://".$device_ip4.":".$device_webport."/devices/add.php", $curl_opts);
    $curl_result = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);

    $_add_log_message = $device_name."(".$device_ip4.")";

    if($curl_result == "Y"){
      $sql .= "'Y')";
      $res = $kvmDB->setData($sql);

      if($res){
        $_add_log_message .= " : Not Confirm";
        inputLog("INFO", $_this_location, $device_name, "K_CREATE", $_this_user, "CODE_DEVICES_003", $_add_log_message);
        $kvmJson->setJsonDataSingle(true);
         header("Content-type:application/json; charset=utf-8");
      }else{
         inputLog("ERROR", $_this_location, $device_name, "K_CREATE", $_this_user, "CODE_DEVICES_004", $_add_log_message);
         $kvmJson->setJsonData("fieldName", "");
         $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_004"));
         $kvmJson->setJsonData("statusType", "error");
         header("HTTP/1.0 500 Menual Error");
      }
    }else{
      inputLog("WARNING", $_this_location, $device_name, "K_CREATE", $_this_user, "CODE_DEVICES_005", $_add_log_message);
      $kvmJson->setJsonData("fieldName", "");
       $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_005"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
    }
    echo $kvmJson->getJsonEncode();
  }

/* ****************** *
 * 외부에서 추가 요청
 *
 * ****************** */
  else{
    $sql .= "'N')";
    $res = $kvmDB->setData($sql);
    $_add_log_message = $device_name."(".$device_ip4.")";
    if($res){
      inputLog("INFO", $_this_location."#".$send_device, $this_device_name, "K_CREATE", $send_user."#", "CODE_DEVICES_013", $_add_log_message);
      echo "Y";
    }else{
      #장비 추가 실패 : 외부에서, 두부에러
      inputLog("ERROR", $_this_location."#".$send_device, $this_device_name, "K_CREATE", $send_user."#", "CODE_DEVICES_014", $_add_log_message);
      echo "N";
    }
  }

  unset($kvmDB,$kvmJson);
?>
