<?php


if(isset($_SERVER['HTTP_REFERER'])){
  $referer = parse_url($_SERVER['HTTP_REFERER']);
}else{
  exit();
}

require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';
$kvmDB = new kvmDB();
$kvmJson = new kvmJson();
$_error_code = $output = "";

//seq확인
if(isset($_POST["seq"]) == true && $_POST["seq"] != ""){
  $seq = $_POST["seq"];
  $set_sql = "UPDATE devices_data SET pending = '' where seq = '".$seq."'";
   if($kvmDB->getDataSingle("SELECT local FROM devices_data WHERE seq='".$seq."'") == "Y") exit();
}else{
  exit();
}

$is_confirm = isset($_POST["confirm"]) ? isset($_POST["confirm"]) : false;

//내장비에서 승인
if($is_confirm == true){
  //자기자신 등록
  $rs = $kvmDB->getData("SELECT ip4,web_port,name FROM devices_data WHERE seq='".$seq."'");
  if($row = $rs->fetchArray()) {
    $ip = $row["ip4"];
    $port = $row["web_port"];
    $name = $row["name"];
  }
  unset($rs,$row);

  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';
  $curl = new CURL();
  $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_POST => true,
      CURLOPT_CONNECTTIMEOUT => 3,
      CURLOPT_REFERER => "http://".$_SERVER["HTTP_HOST"],
      CURLOPT_POSTFIELDS => "seq=".$_local_device_seq."&name=".$_local_device_name."&user=".$_SESSION['user_id']
  );
  $curl->addSession("http://".$ip.":".$port."/devices/confirm.php", $curl_opts);
  $curl_result = $curl->exec();
  $curl->clear();
  unset($crul,$curl_opts);

  $log_info = array(
    "stat" => "",
    "location" => "",
    "target" => $name,
    "user" => $_SESSION['user_seq'],
    "code" => "",
    "message" => " * ".$name."(".$ip.")"
  );

  if($curl_result == "Y"){

    $res = $kvmDB->setData($set_sql);
    if($res){
      $_is_error = false;
      $log_info["stat"] = "INFO";
      $log_info["code"] = "CODE_DEVICES_017";
    }else{
      $_is_error = true;
      $_error_code = "ALERT_EVICES_018";
      $log_info["stat"] = "ERROR";
      $log_info["code"] = "CODE_DEVICES_018";
    }

  }else{

    $_is_error = true;
    $_error_code = "ALERT_EVICES_019";
    $log_info["stat"] = "ERROR";
    $log_info["code"] = "CODE_DEVICES_019";

  }

  if($_is_error == false){
    $kvmJson->setJsonDataSingle(true);
    header("Content-type:application/json; charset=utf-8");
  }else{
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg($_error_code));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
  }
  $output = $kvmJson->getJsonEncode();

}
//요청 승인 받음
else{
  $send_device_name = isset($_POST['name']) ? $_POST['name'] : "";
  $send_device_user = isset($_POST['user']) ? $_POST['user'] : "";

  $is_device_ip = $kvmDB->getDataSingle("SELECT ip4 FROM devices_data WHERE seq = '".$seq."' AND active = 'Y'");

  $log_info = array(
    "stat" => "",
    "location" => "#".$seq,
    "target" => $_local_device_name,
    "user" => $send_device_user."#",
    "code" => "",
    "message" => " * ".$send_device_name."(".$is_device_ip.")"
  );

  if($is_device_ip != ""){
    $res = $kvmDB->setData($set_sql);
    if($res){

      $log_info["stat"] = "INFO";
      $log_info["code"] = "CODE_DEVICES_020";
      $output = "Y";

    }else{
      $log_info["stat"] = "ERROR";
      $log_info["code"] = "CODE_DEVICES_021";
      $output = "N";
    }
  }else{
      $log_info["stat"] = "ERROR";
      $log_info["code"] = "CODE_DEVICES_022";
    $output = "N";
  }
}

//로그 남기기
if(isset($log_info) == true && is_array($log_info) == true){
  inputLog($log_info["stat"]
       , "L_DEVICES".$log_info["location"]
       , $log_info["target"]
       , "K_CONFIRM"
       , $log_info["user"]
       , $log_info["code"]
       , $log_info["message"]
  );
}

echo $output;
unset($kvmDB,$kvmJson);
?>