<?php
//session_start();

require_once '_common.php';

//삭제하려는 디바이스 정보

//로컬장비 삭제 불가
if($is_local == "Y"){
  inputLog("WARNING", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_006", "");
  $kvmJson->setJsonData("fieldName", "");
  $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_006"));
  $kvmJson->setJsonData("statusType", "error");
  header("HTTP/1.0 500 Menual Error");
  exit($kvmJson->getJsonEncode());
}

//등록된 디바이스 아니면 오류
if($already_reg_device == "0" || $already_reg_device == "2"){
  if($is_external_request){
    $_add_log_message = $device_name."(".$_SERVER['REMOTE_ADDR'].")";
    inputLog("WARNING", $_this_location."#".$send_device, $this_device_name, "K_DELETE", $send_user."#", "CODE_DEVICES_023", $_add_log_message);
    echo "N";
  }else{
    $_add_log_message = $device_name."(".$device_ip4.")";
    inputLog("WARNING", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_024", $_add_log_message);
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_024"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    echo $kvmJson->getJsonEncode();
  }
  exit();
}

$sql = "UPDATE devices_data SET
          active = 'N',
          subnet4 = '',
          gateway4 = '',
          dns1 = '',
          dns2 = '',
          date = DATETIME('NOW','localtime')
          WHERE seq = '".$device_seq."'";

$user_map_sql = "DELETE FROM user_device_map WHERE device = '".$device_seq."'";

$force_delete = isset($_POST['force']) ? $_POST['force'] : "N";

if($force_delete == "Y"){
  $res = $kvmDB->setData($sql);
  $deleted_device_name = $kvmDB->getDataSingle("SELECT name FROM devices_data WHERE seq = '".$device_seq."'");
  $deleted_device_ip = $kvmDB->getDataSingle("SELECT ip4 FROM devices_data WHERE seq = '".$device_seq."'");
  $_add_log_message = $deleted_device_name."(".$deleted_device_ip.")";
  if($res){
    $kvmDB->setData($user_map_sql);
     inputLog("INFO", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_007", $_add_log_message);
    $kvmJson->setJsonDataSingle(true);
     header("Content-type:application/json; charset=utf-8");
  }else{
    inputLog("ERROR", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_008", $_add_log_message);
     $kvmJson->setJsonData("fieldName", "");
     $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_008"));
     $kvmJson->setJsonData("statusType", "error");
     header("HTTP/1.0 500 Menual Error");
  }
  exit($kvmJson->getJsonEncode());
}else{

/* ************************** *
 * 로컬에서 외부 장비 삭제
 * ************************** */
  if($send_device == ""){
    //일반유저 작업불가
    if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){
      inputLog("WARNING", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_009", "");
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_009"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }
    //원격에 내 정보를 보내줘야 함
     $curl_data = "&seq=".$this_device_seq."&send_device=".$this_device_seq."&send_user=".$_SESSION['user_id']."&name=".$this_device_name;
    $curl = new CURL();
    $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_POST => true,
      CURLOPT_CONNECTTIMEOUT => 5,
      CURLOPT_POSTFIELDS => $curl_data
    );
    $curl->addSession( "http://".$current_ip4.":".$current_webport."/devices/delete.php", $curl_opts);
    $curl_result = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);
    $_add_log_message = $current_name."(".$current_ip4.")";
    if($curl_result == 'Y'){
      $res = $kvmDB->setData($sql);
      if($res){
        $kvmDB->setData($user_map_sql);
         inputLog("INFO", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_010", $_add_log_message);
        $kvmJson->setJsonDataSingle(true);
         header("Content-type:application/json; charset=utf-8");
      }else{
        #장비 삭제 실패 : 두부에러
        inputLog("ERROR", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_011", $_add_log_message);
         $kvmJson->setJsonData("fieldName", "");
         $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_011"));
         $kvmJson->setJsonData("statusType", "error");
         header("HTTP/1.0 500 Menual Error");
      }
    }else{
      #장비삭제 실패 : 응답없음
      inputLog("WARNING", $_this_location, $device_name, "K_DELETE", $_this_user, "CODE_DEVICES_012", $_add_log_message);
      $kvmJson->setJsonData("fieldName", "force");
       $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_012"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
    }
    echo $kvmJson->getJsonEncode();
  }

/* ************************** *
 * 외부에서 삭제 요청
 * ************************** */
  else{

    $_add_log_message = $device_name."(".$_SERVER['REMOTE_ADDR'].")";

    if(isset($_POST['init']) && $_POST['init'] == "y"){
      $log_location = "L_SETTINGS#".$send_device;
      $is_init = true;
    }else{
      $log_location = $_this_location."#".$send_device;
      $is_init = false;
    }
    $res = $kvmDB->setData($sql);
    if($res){
      #장비삭제 성공 : 외부에서 요청
      $kvmDB->setData($user_map_sql);
      $log_code = ($is_init == true) ? "CODE_DEVICES_041" : "CODE_DEVICES_015";
      inputLog("INFO", $log_location, $this_device_name, "K_DELETE", $send_user."#", $log_code, $_add_log_message);
      echo "Y";
    }else{
      #장비 삭제 실패 : 외부에서 요청, 두부에러
      $log_code = ($is_init == true) ? "CODE_DEVICES_042" : "CODE_DEVICES_016";
      inputLog("ERROR", $log_location, $this_device_name, "K_DELETE", $send_user."#", $log_code, $_add_log_message);
      echo "N";
    }
  }
}
  unset($kvmDB,$kvmJson);
?>
