<?php
/* ***************************** *
 * Local Device Real Infomation
 ******************************* */
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/ini.php';

//ip
$local_dev_ip= $_SERVER["SERVER_ADDR"];

//port
$local_dev_port = $_SERVER["SERVER_PORT"];
/*
exec('grep server.port '.$_httpd_config_file,$port_info);
if($port_info){
  $local_dev_port = str_replace("server.port = ","",$port_info[0]);
}
unset($port_info);
*/

//맥어드레스,seq
exec("ifconfig eth0",$local_dev_info);
$local_dev_mac= "";
$local_dev_seq = "";
if($local_dev_info) {
  preg_match("/\b([\dA-Fa-f]{2}?:*){6}$/",$local_dev_info[0],$mac_info);
  $local_dev_mac = $mac_info[0];
  unset($mac_info);
}
else{
  for ($i=0; $i<6; $i++){
    $local_dev_mac .= str_pad(strtoupper(dechex(mt_rand(0, 255))),2,"0",STR_PAD_LEFT).":";
  }
  $local_dev_mac = substr($local_dev_mac,0,-1);
}
unset($local_dev_info);
//$mac_digit = split("[:-]", $local_dev_mac);
$mac_digit = explode(":", $local_dev_mac);
foreach($mac_digit as $digit) $local_dev_seq .= hexdec($digit);
unset($mac_digit);
$local_dev_seq = base52($local_dev_seq);


//네트워크 정보
$local_dev_subnet = "255.255.0.0";
$local_dev_gateway = "192.168.1.1";
if(is_file($_network_config_file)){
  $ini = new INIManager($_network_config_file);
  if(!$ini->Initialize(true)){
  }else{
    $arrGet = $ini->getINIData();
    $local_dev_subnet = $arrGet['NETMASK'];
    $local_dev_gateway = $arrGet['GATEWAY'];
    unset($arrGet);
  }
  unset($ini);
}

//DNS정보
$local_dev_dns1 = "168.126.63.1";
$local_dev_dns2 = "168.126.63.2";
if(is_file($_dns_server_file)){
  $dns_data = file_get_contents($_dns_server_file);
  $dns_data = str_replace("\n","",$dns_data);
  $dns_data = str_replace("\r","",$dns_data);
  $dns_data = str_replace(" ","",$dns_data);
  if($dns_data != ""){
    $local_dev_dns = explode("nameserver",$dns_data);
    $local_dev_dns1 = $local_dev_dns[1];
    if(!empty($local_dev_dns[2])){
      $local_dev_dns2 = $local_dev_dns[2];
    }else{
      $local_dev_dns2 = "";
    }
    unset($local_dev_dns);
  }
}

if(isset($_REQUEST['external'])){
  //장비 정보 json으로 보내기
}

function updateLocalDeviceInfoToDB(){
  $kvmDB = new kvmDB();
  $is_device = $kvmDB->getDataSingle("SELECT seq FROM devices_data WHERE local = 'Y'");
  if($is_device == ""){
     return false;
  }else{
    $sql = " UPDATE devices_data SET
             ip4 = '".$GLOBALS['local_dev_ip']."',
             subnet4 = '".$GLOBALS['local_dev_subnet']."',
             gateway4 = '".$GLOBALS['local_dev_gateway']."',
             web_port = '".$GLOBALS['local_dev_port']."',
             dns1 = '".$GLOBALS['local_dev_dns1']."',
             dns2 = '".$GLOBALS['local_dev_dns2']."'
             WHERE local = 'Y' ";
    $kvmDB->setData($sql);
    //$sql_mac = " UPDATE preference SET device_mac = '".$GLOBALS['local_dev_mac']."'";
    //$kvmDB->setData($sql_mac);
  }


  unset($kvmDB);
}
?>