<?php
  require_once $_SERVER['DOCUMENT_ROOT'].'/devices/newest.php';
  updateLocalDeviceInfoToDB();

  //$device_seq = isset($_GET["device_seq"]) ? $_GET["device_seq"] : $_SESSION["device_seq"];

  require_once '_common.php';
  $call_location = isset($_GET["call_location"]) ? $_GET["call_location"] : "local";
  $kvmDB = new kvmDB();
  $kvmJson = new kvmJson();

  $is_setup = $kvmDB->getDataSingle("SELECT is_setup FROM preference");
  $is_device = $kvmDB->getDataSingle("SELECT seq FROM devices_data WHERE local = 'Y'");
  if($is_setup != "Y" || $is_device == ""){
    header("HTTP/1.0 500 Menual Error");
    echo $_GET["callback"]."('error')";
    exit();
  }

  if($call_location == "external"){
    if(isset($_GET["callback"])){
      $rs_array = Array();
      $rs_array['seq'] = $this_device_seq;
      $rs_array['name'] = $this_device_name;
      $rs_array['ip4'] = $this_device_ip4;
      $rs_array['ip6'] = $this_device_ip6;
      $rs_array['subnet4'] = $this_device_subnet4;
      $rs_array['subnet6'] = $this_device_subnet6;
      $rs_array['gateway4'] = $this_device_gateway4;
      $rs_array['gateway6'] = $this_device_gateway6;
      $rs_array['web_port'] = $this_device_web_port;
      $rs_array['dns1'] = $this_device_default_dns;
      $rs_array['dns2'] = $this_device_sub_dns;

      $kvmJson->setJsonArray($rs_array);

      header("Content-type:text/javascript; charset=utf-8");
      echo $_GET["callback"]."([".$kvmJson->getJsonEncode()."])";
      unset($rs_array);
    }else{
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", "No callback!");
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
    }
  }
/* ***********
  else{

  }
************ */
  unset($kvmDB);
  unset($kvmJson);
?>