<?php
  $_this_target = "LOCATION#L_SETTINGS_SECURITY";
  if(!defined("_KVM_SETTING")){
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
    $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
    inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
  }

  $iptable = array();

  $rs = $kvmDB->getData("SELECT ip, netmask FROM ip_table WHERE option = 'A' ");
  $i = 0;
  while($row = $rs->fetchArray()){
    $iptable[$i] = array("ip" => $row["ip"], "netmask" => $row["netmask"], "option" => $row["option"]);
    $i++;
  }

  $iptable_value = "";
  if(count($iptable) > 0){
    for($i=0;$i<count($iptable);$i++){
      $iptable_value .= $iptable[$i]['ip']." / ".$iptable[$i]['netmask']."\n";
    }
  }else{
    $iptable_value = "Access All";
  }


  $_add_log_message = "";
  if(isset($_POST['security_setting']) && $_POST['security_setting'] == "Y"){
    $arrIP = $_POST['ip'];
    $arrNetmask = $_POST['netmask'];
    $arrNetmask_dec = array();

    for($i=0;$i<count($arrNetmask);$i++){
      if(strpos($arrNetmask[$i],".")){
        $mask_arr = explode(".",$arrNetmask[$i]);
        $boolin_mask = "";
        foreach($mask_arr as $digit){
          $boolin_mask .= decbin($digit);
        }
        $arrNetmask_dec[$i] = strlen(str_replace("0","",$boolin_mask));
        unset($mask_arr);
      }else{
        $arrNetmask_dec[$i] = $arrNetmask[$i];
      }
    }

    //쉘 실행파일 만들기
    $iptable_sh_text="iptables -F";
    $iptable_new_value = "";
    if(count($_POST['ip']) > 0){
      for($i = 0; $i < sizeof($arrIP); $i++){
        if(strlen(trim($arrIP[$i])) > 1){
          $iptable_sh_text .= "\niptables -A INPUT -p TCP -s ".$arrIP[$i];
          if(strlen(trim($arrNetmask_dec[$i]))) $iptable_sh_text .= "/".$arrNetmask_dec[$i];
          $iptable_sh_text .= " -j ACCEPT";
          $iptable_new_value .= $arrIP[$i]." / ".$arrNetmask[$i]."\n";
        }
      }
      $iptable_sh_text .= "\niptables -A INPUT -p TCP -j DROP";
    }else{
      $iptable_new_value = "Access All";
    }
    $iptable_sh_text .= "\n/usr/local/sbin/iptables-save > /etc/iptables.rule";
    //$iptable_sh_text .= "\niptables -nL";
    file_put_contents('/etc/iptable.sh', $iptable_sh_text);
    @chmod('/etc/iptable.sh',0777);

    $res_send = true;

    /*
    //소켓통신
    require_once $_SERVER['DOCUMENT_ROOT']."/_common/socket.php";
    $command = '/etc/iptable.sh';
    $kvmServer = new kvmServer();
    $kvmMessage = new kvmMessage(HeaderType::IPTABLE, $command);

    //echo "address -> ".$address.":".$port."<br>";
    if($kvmServer->connect($address, $port)){
      //echo "접속 성공<br>";
      $sendMessage = $kvmMessage->getMessageDirect();
      //echo "message -> ".$sendMessage."<br>";
      if($kvmServer->send($kvmMessage->getMessageDirect())){
        echo "보내기 성공<br>";
        $res_send = true;
      }else{
        inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_013", "");
        $kvmJson->setJsonData("fieldName", "");
         $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_013"));
         $kvmJson->setJsonData("statusType", "error");
         header("HTTP/1.0 500 Menual Error");
        exit($kvmJson->getJsonEncode());
      }
    }else {
      inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_013", "");
      $kvmJson->setJsonData("fieldName", "");
       $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_013"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }

    unset($kvmServer);
    unset($kvmMessage);

    //unlink('/etc/iptable.sh');
    */
    $_add_log_message = "<table><tr><td>".$iptable_value."</td><td> → </td><td>".$iptable_new_value."</td></tr></table>";
    if($res_send === true){
      $sql = "DELETE FROM ip_table WHERE option = 'A'";
      $res = $kvmDB->setData($sql);

      if($res){
        $sql = "";
        for($i = 0; $i < sizeof($arrIP); $i++){
          if(strlen(trim($arrIP[$i])) > 1)
            $sql .= "INSERT INTO ip_table VALUES (null, '".$arrIP[$i]."', '".$arrNetmask[$i]."', 'A'); ";
        }
        $res2 = $kvmDB->setData($sql);
      }

      if($res2){
        inputLog("INFO", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_012", $_add_log_message);
      }else{
        inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_014", "");
        $kvmJson->setJsonData("fieldName", "");
         $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_014"));
         $kvmJson->setJsonData("statusType", "error");
         header("HTTP/1.0 500 Menual Error");
        exit($kvmJson->getJsonEncode());
      }
    }

    unset($arrIP,$arrNetmask,$arrNetmask_dec,$iptable_sh_text);
  }
?>
  <input type="hidden" name="security_setting" value="Y" />
  <h2 class="caption"><?=msg('SETTINGS_501')?></h2>
  <p><?=msg('SETTINGS_502')?></p>
  <div id="iptable">
    <input name="setting_security" value="Y" type="hidden" />
    <? for($i=0;$i<count($iptable);$i++){ ?>
    <fieldset class="item allowed-ip" title="0">
      <div class="tools">
        <a href="#moveUpItem" class="button-move-up" title="Move Up" tabindex="-1">Up</a>
        <a href="#moveDownItem" class="button-move-down" title="Move Down" tabindex="-1">Down</a>
        <a href="#removeAddress" class="button-del" title="Delete item?" tabindex="-1">Delete item</a>
      </div>
      <label>IP</label> <input id="ip-<?=$i+1?>" name="ip[]" value="<?=$iptable[$i]['ip']?>" type="text">
      <label>Netmask</label> <input id="mask-<?=$i+1?>" name="netmask[]" value="<?=$iptable[$i]['netmask']?>" type="text">
    </fieldset>
    <? } ?>
  </div>
<?php
  unset($iptable);
?>