<?php
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

  $is_setup = setupCheck('boolean');
  if($is_setup == true) header('Location: /');
  if(isset($_POST['setup']) && $_POST['setup'] == 'Y'){

    if(!isset($_POST['seq']) || !isset($_POST['name']) || !isset($_POST['ip']) || !isset($_POST['subnet']) || !isset($_POST['gateway']) ||
       !isset($_POST['mac']) || !isset($_POST['port']) || !isset($_POST['dns1']) || !isset($_POST['dns2']) ||
       !isset($_POST['id']) || !isset($_POST['pw']) || !isset($_POST['pw2']) ||
       $_POST['seq'] == "" || $_POST['name'] == "" || $_POST['ip'] == "" || $_POST['mac'] == "" || $_POST['subnet'] == "" ||
       $_POST['gateway'] == "" || $_POST['port'] == "" || $_POST['id'] == "" || $_POST['pw'] == "" || $_POST['pw'] != $_POST['pw2'] ){
      header('Location: /');
    }

    $device_seq = $_POST['seq'];
    $device_name = $_POST['name'];
    $device_ip = $_POST['ip'];
    $device_mac = $_POST['mac'];
    $device_subnet = $_POST['subnet'];
    $device_gateway = $_POST['gateway'];
    $device_port = $_POST['port'];
    $device_dns1 = $_POST['dns1'];
    $device_dns2 = $_POST['dns2'];
    $user_seq = base52(substr(time().rand(10,99), 2));
    $user_id = $_POST['id'];
    $user_pw = cryptPW($_POST['pw']);
    $firmware = $_POST['firmware'];
    $language = $_POST['language'];
    $pc_type = $_POST['pctype'];

    $post_network_set = "&device_seq=".$device_seq."&device_name=".$device_name."&device_ip=".$device_ip."&device_mac=".$device_mac.
                        "&device_subnet=".$device_subnet."&device_gateway=".$device_gateway."&device_port=".$device_port.
                        "&device_dns1=".$device_dns1."&device_dns2=".$device_dns2;
    $post_user_set = "&user_id=".$user_id."&user_pw=".$user_pw."&user_seq=".$user_seq."&firmware=".$firmware."&language=".$language."&pctype=".$pc_type;

    if(isset($_POST['local_time'])) exec("date ".$_POST['local_time']);
?><!DOCTYPE HTML>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta charset="utf-8">
  <meta http-equiv="content-language" content="en">
  <meta name="robots" content="noindex, noarchive, nofollow">
  <meta name="viewport" content="width=990" />
  <title>Install - RemoteKVM</title>
  <link rel="Shortcut Icon" type="image/ico" href="/favicon.ico">
  <link rel="stylesheet" media="screen, projection" type="text/css" href="/public/stylesheets/global.css">
</head>
<body>
<div id="kvmWrap" class="bg">
  <div id="left">
    <div class="logo">
      <h1><a href="/">RemoteKVM</a></h1>
    </div>

    <div class="tip middle" style="margin-top: -220px;">
      <ul class="number">
        <li><?=msg('SETUP_001')?></li>
        <li class="current"><?=msg('SETUP_002')?></li>
        <li><?=msg('SETUP_003')?></li>
      </ul>
    </div>

    <?php include $_SERVER['DOCUMENT_ROOT'].'/_common/version.php'; ?>
  </div>
  <div id="content">
      <div class="simple" style="position:absolute; top:27%;">
        <fieldset class="last">
          <legend><?=msg('SETUP_101')?></legend>
          <p class="description"><strong style="color: #AD0021"><?=msg('SETUP_102')?></strong></p>
          <div id="console"></div>
        </fieldset>

        <div class="buttons">
          <!-- button class="button" id="backBtn">Back</button -->
          <button class="button none" id="finishBtn" style="float:right;"><?=msg('SETUP_203')?></button>
        </div>
      </div>
  </div>
</div>
<script type="text/javascript" src="/public/javascripts/jquery.min.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.base.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.setup.js"></script>
<script type="text/javascript">
  $addr = '<?=$device_ip.":".$device_port?>';
  ok_str = '<?=msg('SETUP_201')?>';
  error_str = '<?=msg('SETUP_202')?>';
  error_message = '<?=msg('SETUP_204')?>';
  log(null, '<?=msg('SETUP_103')?>');
  log('/setup/istreamer.php', '<?=msg('SETUP_104')?>');
  log('/setup/network.php?action=check', '<?=msg('SETUP_105')?>');
  log('/setup/network.php?action=apply<?=$post_network_set?>', '<?=msg('SETUP_106')?>');
  log('/setup/media.php?action=check', '<?=msg('SETUP_107')?>');
  log('/setup/media.php?action=apply', '<?=msg('SETUP_108')?>');
  log(null, '<?=msg('SETUP_109')?>');
  log('/setup/database.php?action=check', '<?=msg('SETUP_110')?>');
  log('/setup/database.php?action=apply<?=$post_network_set.$post_user_set?>', '<?=msg('SETUP_111')?>');
<?php if($_POST['current_ip'] != '1.1.1.1') {?>
  log('done', '<?=msg('SETUP_112')?>');
  log(null, '<?=msg('SETUP_113')?>');
  log('/devices/reboot.php?device=<?=$device_seq?>&user=<?=$user_seq?>', '<?=msg('SETUP_114')?>');
<?php }else{?>
  log(null, '<?=msg('SETUP_112')?>');
  log('mreboot', '<?=msg('SETUP_115')?>');
  log(null, '');
<?php } ?>
</script>
</body></html>
<?php
  }
  else{ header('Location: /'); }
?>