<?php
  //session_start();

  require_once '_common.php';

 //일반 유저가 만들려고 하는 경우 오류
  if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){
    inputLog("WARNING", $_this_location, "", "K_CREATE", $_this_user, "CODE_USERS_002", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_002"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }

  //아이디 없을경우 오류
  if(!$admin_id){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_101"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }

  //비번 없거나 안맞을 경우
  if((!($admin_pw || $admin_pw_confirm)) || !($admin_pw == $admin_pw_confirm)){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_102"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit( $kvmJson->getJsonEncode());
  }

  //super user를 만드려고 할때 오류
  if($admin_type == 'super'){
    inputLog("WARNING", $_this_location, "", "K_CREATE", $_this_user, "CODE_USERS_003", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_003"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }

  //같은 아이디 있을경우  오류
  $sql = "SELECT seq FROM users_data WHERE id = '".$admin_id."' AND active = 'Y'";
  $exid = $kvmDB->getDataSingle($sql);
  if($exid || (preg_match("/admin|root/",$admin_id) > 0 && $admin_type != 'super') || preg_match("/undefined|system|device|unknown/",$admin_id) > 0){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_103"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }else{
    $admin_seq = substr(time().rand(10,99), 2);
    $sql = "INSERT INTO users_data (seq,id,pw,type,active,date) VALUES (
            '".base52($admin_seq)."',
            '".$admin_id."',
            '".cryptPW($admin_pw)."',
            '".$admin_type."',
            'Y',
            DATETIME('NOW','localtime'))";
    $res = $kvmDB->setData($sql);
    $_add_log_message = " * ID : ".$admin_id."\n";
    $_add_log_message .= " * Type : ".$admin_type."\n";
  }

  if($res){
    $this_user_seq = $kvmDB->getDataSingle("SELECT seq FROM users_data WHERE id = '".$admin_id."' ORDER BY date DESC LIMIT 1");

    if($admin_type == 'user' && $device_seq != null){
      $_add_log_message .= " * Accessable Device : ";
      for($i=0; $i<count($device_seq);$i++){
        $kvmDB->setData("INSERT INTO user_device_map VALUES ( null, '".$this_user_seq."', '".$device_seq[$i]."')");
        $_add_log_message .= $device_name[$i].",";
      }
      $_add_log_message = substr($_add_log_message,0,-1);
    }

    inputLog("INFO", $_this_location, $admin_id, "K_CREATE", $_this_user, "CODE_USERS_004", $_add_log_message);
    $kvmJson->setJsonData("seq", $this_user_seq);
    header("Content-type:application/json; charset=utf-8");
  }
  else{
    inputLog("ERROR", $_this_location, $admin_id, "K_CREATE", $_this_user, "CODE_USERS_001", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_001"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
  }

  echo $kvmJson->getJsonEncode();

  unset($kvmDB);
  unset($kvmJson);
?>
