<?php
  //session_start();

  require_once '_common.php';;

  if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){
    $admin_type ="user";
  }
  $res = false;

  //아이디 없을경우 오류
  if(!$admin_id){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_101"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }

  //비번 안맞을경우 오류
  if(!($admin_pw == $admin_pw_confirm)){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_102"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }

  //이미 아이디 존재할경우 오류
  $sql = "SELECT seq FROM users_data WHERE id = '".$admin_id."' AND seq <> '".$admin_seq."' AND active = 'Y'";
  $exid = $kvmDB->getDataSingle($sql);
  if($exid || (preg_match("/admin|root/",$admin_id) > 0 && $admin_type != 'super') || preg_match("/undefined|system|device|unknown/",$admin_id) > 0){
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_USERS_103"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }else{
    //기존의 값들
    $sql = "SELECT id,pw,type FROM users_data WHERE seq = '".$admin_seq."'";
    $ex_user_info = $exid = $kvmDB->getData($sql);
    while($row = $ex_user_info->fetchArray()){
       $ex_user_id = $row['id'];
       $ex_user_pw = $row['pw'];
       $ex_user_type = $row['type'];
    }
    $_add_log_message = "<b>".$ex_user_id."</b><br />";
    if($admin_id != $ex_user_id) {
      $_add_log_message .= " * ID : ".$ex_user_id." → ".$admin_id."\n";
      if($admin_seq == $_SESSION['user_seq']) $_SESSION['user_id'] = $admin_id;
    }
    if(trim($admin_pw) != "" && cryptPW($admin_pw) != $ex_user_pw) $_add_log_message .= " * Password change\n";
    if($admin_type != $ex_user_type) {
      $_add_log_message .= " * type : ".$ex_user_type." → ".$admin_type."\n";
      if($admin_seq == $_SESSION['user_seq']) $_SESSION['user_type'] = $admin_type;
    }

    $sql = " UPDATE users_data SET id = '".$admin_id."' ";
    //비번이 바뀌었을때
    if(trim($admin_pw) != "") $sql .= ", pw = '".cryptPW($admin_pw)."' ";
    //수퍼유저 type은 변경불가
    if($admin_seq != $super_seq) $sql .= ", type = '".$admin_type."' ";
    $sql .=" WHERE seq = '".$admin_seq."' ";
    $res = $kvmDB->setData($sql);


    $user_devices = $kvmDB->getData("SELECT di.name FROM devices_data di, user_device_map dm
                                     WHERE di.seq = dm.device AND dm.user = '".$admin_seq."' AND local = 'N'");
    $ex_access_device_list = "";
    $j = 0;
    while($row_d = $user_devices->fetchArray()){
      $ex_access_device_list .= $row_d['name']."\n";
      $j++;
    }
    if($j < 1){
      $ex_access_device_list = "No accessible external device";
    }

    $kvmDB->setData("DELETE FROM user_device_map WHERE user = '".$admin_seq."'");

    if($admin_type == 'user' && $device_seq == null){
      $new_access_device_list = "No accessible external device";
      $change_device_access = true;
    }
    elseif($admin_type == 'user' && $device_seq != null){
      $new_access_device_list = "";
      for($i=0; $i<count($device_seq);$i++){
        $kvmDB->setData("INSERT INTO user_device_map VALUES ( null, '".$admin_seq."', '".$device_seq[$i]."')");
        $new_access_device_list .= $device_name[$i]."\n";
      }
      $change_device_access = true;
      //일반유저로 바뀌었을시 새로고침하고 새션 변경
    }
    if(isset($change_device_access) && $change_device_access === true){
      $_add_log_message .= " * Accessable Device :<br/><table><tr><td>".$ex_access_device_list."</td><td> → </td><td>".$new_access_device_list."</td></tr></table>";
    }

  }

  if($res){
    inputLog("INFO", $_this_location, $ex_user_id, "K_MODIFY", $_this_user, "CODE_USERS_011", $_add_log_message);
    $kvmJson->setJsonDataSingle(true);
    header("Content-type:application/json; charset=utf-8");
  }
  else{
    inputLog("ERROR", $_this_location, $ex_user_id, "K_MODIFY", $_this_user, "CODE_USERS_010", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("USER002"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
  }

  echo $kvmJson->getJsonEncode();

  unset($kvmDB);
  unset($kvmJson);
?>
