<?php
require_once '_common.php';

$rview_json = new kvmJson();
header("Content-type:application/json; charset=utf-8");

if(isset($_POST['step']) === false || $_POST['step'] == null){
  $rview_json->setJsonData("type", "error");
  $rview_json->setJsonData("message", "require step!");
  jsonEchoEnd();
}

switch($_POST['step']){
//LOGIN ================================
  case "userCheck":
    if(isset($_POST['SERVERADDR'])){
      $rview_domain = $_POST['SERVERADDR'];
    }else{
      $rview_domain = $default_domain;
    }
    $rview_data['type'] = (!getResponse('companyCheck') || !getResponse('userCheck')) ? 'error' : 'ok';

    if($rview_data['type'] === 'ok'){
      $set_rview_ini_data = array(
        'GroupID' => $rview_data['GROUPID'],
        'BizID' => $rview_data['BIZID'],
        'WebServer' => $rview_domain
      );
      setRviewINI($set_rview_ini_data);
    }
  break;

//AGENT SETUP ==========================
  case "regAgent":
    $rview_data['DISPLAYNAME'] = $_local_device_name;
    $rview_data['SHAREDFOLDER'] = '';
    $rview_data['SSL'] = '';
    $rview_data['AGENTIP'] = $_local_device_ip;
    $rview_data['AGENTMAC'] = str_replace(':','',$_local_device_mac);
    $rview_data['PCNAME'] = '';
    $rview_data['OSNAME'] = '';
    $rview_data['RSVFLAG'] = '50';
    $rview_data['GUID'] = strtoupper(md5($_local_device_seq.time()));

    //validation
    if($_POST['ACCESSPWD'] != $_POST['ACCESSPWD2']){
      $rview_data['type'] = "error";
      $rview_data['message'] = msg('RVIEW_402');
      jsonEchoEnd();
    }else{
      $rview_data['ACCESSPASSWD'] = $_POST['ACCESSPWD'];
    }

    $rview_data['type'] = (!getResponse('validate') || !getResponse('install')) ? 'error' : 'ok';

    //ini 파일 등록
    if($rview_data['type'] === 'ok'){
      $set_rview_ini_data = array(
        'GUID' => $rview_data['GUID']
      );
      setRviewINI($set_rview_ini_data);
      inputLog("INFO", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_041", "");
      exec("/etc/init.d/rvagent start", $output);
    }
  break;
}

jsonEchoEnd();
?>