<?php
  error_reporting(E_ERROR);
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';
  $_this_location = "L_DEVICES";
  $_this_user = $_SESSION['user_seq'];

  $kvmDB = new kvmDB();
  $kvmJson = new kvmJson();

  $is_setup = $kvmDB->getDataSingle("SELECT is_setup FROM preference");
  $is_device = $kvmDB->getDataSingle("SELECT seq FROM devices_data WHERE local = 'Y'");
  if($is_setup != "Y" || $is_device == ""){
    header("HTTP/1.0 500 Menual Error");
    echo $_GET["callback"]."('error')";
    exit();
  }

  //입력된 정보 validate
  if(isset($_REQUEST["seq"])){
    $device_seq = $_REQUEST["seq"];
    $is_local_sql = "SELECT local FROM devices_data WHERE seq = '".$device_seq."'";
    $is_local = $kvmDB->getDataSingle($is_local_sql);
  }else{
    $device_seq = $is_device;
    $is_local = 'Y';
  }
  if(isset($_REQUEST["name"])){
    if($_REQUEST["name"] != ""){
      $device_name = $_REQUEST["name"];
    }else{
      $device_name = $_REQUEST["name"];
    }
  }else{
    $device_name_sql = "SELECT name FROM devices_data WHERE seq = '".$device_seq."'";
    $device_name = $kvmDB->getDataSingle($device_name_sql);
  }
  if(isset($_REQUEST['send_device'])){
    $send_device = $_REQUEST['send_device'];
    //$is_external_request = ($_REQUEST["seq"] == $_REQUEST['send_device']) ? false : true;

    $is_valid_device_sql = "SELECT local FROM devices_data WHERE seq = '".$send_device."'";
    $is_valid_device = $kvmDB->getDataSingle($is_valid_device_sql);
    $is_external_request = ($is_valid_device == "N") ? true : false;

  }else{
    $send_device = "";
    $is_external_request = false;
  }
  $send_user = isset($_REQUEST['send_user']) ? $_REQUEST['send_user'] : "";

  $current_ip4 = isset($_REQUEST["current_ip4"]) ? $_REQUEST["current_ip4"] : "";
  $current_webport = isset($_REQUEST["current_port"]) ? $_REQUEST["current_port"] : "";
  $current_name = isset($_REQUEST["current_name"]) ? $_REQUEST["current_name"] : "";
  $current_subnet = isset($_REQUEST["current_subnet"]) ? $_REQUEST["current_subnet"] : "";
  $current_gateway = isset($_REQUEST["current_gateway"]) ? $_REQUEST["current_gateway"] : "";
  $current_dns1 = isset($_REQUEST["current_dns1"]) ? $_REQUEST["current_dns1"] : "";
  $current_dns2 = isset($_REQUEST["current_dns2"]) ? $_REQUEST["current_dns2"] : "";

  //$other_device = isset($_REQUEST["other_device"]) ? $_REQUEST["other_device"] : "";
  $device_ip4 = isset($_REQUEST["ip4"]) ? $_REQUEST["ip4"] : "";
  $device_ip6 = isset($_REQUEST["ip6"]) ? $_REQUEST["ip6"] : "";
  $device_subnet4 = isset($_REQUEST["subnet4"]) ? $_REQUEST["subnet4"] : "";
  $device_subnet6 = isset($_REQUEST["subnet6"]) ? $_REQUEST["subnet6"] : "";
  $device_gateway4 = isset($_REQUEST["gateway4"]) ? $_REQUEST["gateway4"] : "";
  $device_gateway6 = isset($_REQUEST["gateway6"]) ? $_REQUEST["gateway6"] : "";
  $device_webport = isset($_REQUEST["web_port"]) ? $_REQUEST["web_port"] : "";
  $device_dns1 = isset($_REQUEST["dns1"]) ? $_REQUEST["dns1"] : "";
  $device_dns2 = isset($_REQUEST["dns2"]) ? $_REQUEST["dns2"] : "";

  //로컬 장비정보
  $this_device_sql = "SELECT * FROM devices_data WHERE local = 'Y'";
  $rs = $kvmDB->getData($this_device_sql);
  if($row = $rs->fetchArray()) {
    $this_device_seq = $row["seq"];
    $this_device_name = $row["name"];
    $this_device_ip4 = $row["ip4"];
    $this_device_ip6 = $row["ip6"];
    $this_device_subnet4 = $row["subnet4"];
    $this_device_subnet6 = $row["subnet6"];
    $this_device_gateway4 = $row["gateway4"];
    $this_device_gateway6 = $row["gateway6"];
    $this_device_web_port = $row["web_port"];
    $this_device_default_dns = $row["dns1"];
    $this_device_sub_dns = $row["dns2"];
  }
  unset($rs);

  //이미 등록된 디바이스인가?
  $already_reg_sql = "SELECT seq,active FROM devices_data WHERE seq = '".$device_seq."'";
  $already_reg_device_info = $kvmDB->getData($already_reg_sql);

  if($row_a = $already_reg_device_info->fetchArray()){
     $already_reg_device_seq = $row_a['seq'];
     $already_reg_device_active = $row_a['active'];

     if($already_reg_device_seq == ""){
       $already_reg_device = "0"; //등록된 디바이스 없음
     }elseif($already_reg_device_active == "Y"){
       $already_reg_device = "1"; //등록된 디바이스 있음
     }elseif($already_reg_device_active == "N"){
       $already_reg_device = "2"; //등록된 디바이스 였으나 삭제됨
     }
  }
  unset($already_reg_device_info);
?>