<?php

  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

  if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){ exit(); }

  $current_device = (isset($_GET['seq']) && $_GET['seq'] != null) ? $_GET['seq'] : "";
  $action_file = "/devices/";
  $section_class = "device";
  $local_action = true;
  include $_SERVER['DOCUMENT_ROOT'].'/devices/list.php';

  //디바이스 최신정보 갱신
  require_once $_SERVER['DOCUMENT_ROOT'].'/devices/newest.php';
  updateLocalDeviceInfoToDB();


  $kvmDB = new kvmDB();
  $sql = "SELECT * FROM devices_data ".
         " WHERE seq = '".$current_device."'";
  $sql_map = "SELECT ai.id FROM user_device_map adm, users_data ai WHERE adm.user = ai.seq AND adm.device = '".$current_device."' AND ai.active = 'Y' ";

  $rs = $kvmDB->getData($sql);
  $rs_u = $kvmDB->getData($sql_map);

  if($row = $rs->fetchArray()){
    $delete_btn = '<a href="#removeItem" class="button remove" title="'.msg('DEVICES_118').'" tabindex="-1">'.msg('BTN_DELETE').'</a>';
    $pending_disable = '';
    if ($row['pending'] != "") $pending_disable = 'disabled="disabled"';
    if ($row['local'] == "Y") $delete_btn = '';
?>
<div id="right" class="<?=$right_class?>">
  <form action="/devices/update.php" method="post" class="main" id="devices">
    <input name="seq" value="<?=$row['seq']?>" type="hidden"/>
    <input name="current_device" value="<?=$row['local']?>" type="hidden"/>
    <input name="current_ip4" value="<?=$row['ip4']?>" type="hidden" />
    <input name="current_port" value="<?=$row['web_port']?>" type="hidden" />
    <input name="current_name" value="<?=$row['name']?>" type="hidden" />
    <input name="current_subnet" value="<?=$row['subnet4']?>" type="hidden" />
    <input name="current_gateway" value="<?=$row['gateway4']?>" type="hidden" />
    <input name="current_dns1" value="<?=$row['dns1']?>" type="hidden" />
    <input name="current_dns2" value="<?=$row['dns2']?>" type="hidden" />

    <fieldset>
      <legend><?=msg('DEVICES_101')?></legend>
      <p><?=msg('DEVICES_102')?></p>
      <label><?=msg('DEVICES_103')?> <strong>*</strong></label><input name="name" value="<?=$row['name']?>" type="text" <?=$pending_disable?> class="readonly" readonly="readonly">
      <label><?=msg('DEVICES_104')?> <strong>*</strong></label><input name="ip4" value="<?=$row['ip4']?>" type="text" <?=$pending_disable?>>
      <label><?=msg('DEVICES_105')?> <strong>*</strong></label><input name="subnet4" value="<?=$row['subnet4']?>" type="text" <?=$pending_disable?>>
      <label><?=msg('DEVICES_106')?> <strong>*</strong></label> <input name="gateway4" value="<?=$row['gateway4']?>" type="text" <?=$pending_disable?>>
      <label><?=msg('DEVICES_107')?> <strong>*</strong></label><input name="web_port" value="<?=$row['web_port']?>" type="number" <?=$pending_disable?>>
      <p class="hint"><?=msg('DEVICES_108')?></p>
    </fieldset>

    <fieldset id="dns-setting">
      <legend><?=msg('DEVICES_109')?></legend>
      <p><?=msg('DEVICES_110')?></p>
      <label><?=msg('DEVICES_111')?></label><input name="dns1" value="<?=$row['dns1']?>" type="text" <?=$pending_disable?>>
      <label><?=msg('DEVICES_112')?></label> <input name="dns2" value="<?=$row['dns2']?>" type="text" <?=$pending_disable?>>
    </fieldset>

    <fieldset id="assigned" class="last">
      <legend><?=msg('DEVICES_113')?></legend>
      <p>
        <?=msg('DEVICES_114A')?><br />
        <?=msg('DEVICES_114B')?>
      </p>
      <ul class="access-users">
<?php
      $is_access_user = false;
      if($row['local'] == 'Y'){
        echo '<li class="all">'.msg('DEVICES_115').'</li>';
        $is_access_user = true;
      }
      while($row_u = $rs_u->fetchArray()){
        echo '<li class="item"><a href="#users/'.$row_u['id'].'">'.$row_u['id'].'</a></li>';
        $is_access_user = true;
      }
      if($is_access_user === false) echo '<li class="all">'.msg('DEVICES_116').'</li>';
?>
      </ul>
    </fieldset>

    <div class="buttons">
      <a href="#saveItem" class="button save dim"><?=msg('BTN_APPLY')?></a>
      <?=$delete_btn?>
      <a href="#createItem" class="button create disabled" style="display: none"><?=msg('BTN_CREATE')?></a>
      <a href="#cancelCreate" class="button cancel" style="display: none"><?=msg('BTN_CANCEL')?></a>
      <a href="#addItem" class="button add"><?=msg('DEVICES_117')?></a>
    </div>

  </form>

</div>
<?php
  }
  unset($kvmDB);
?>
