<?php
  //session_start();

  require_once '_common.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/ini.php';
  $_this_action = "K_MODIFY";

  //내부요청시 admin아니면
  /*
  if($send_device == "" && $_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super"){
    inputLog("WARNING", $_this_location, $device_name, "K_MODIFY", $_this_user, "CODE_DEVICES_029", "");
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_029"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    unset($kvmDB,$kvmJson);
    exit($kvmJson->getJsonEncode());
  }
  */

  //등록된 디바이스 아니면 오류
  if($already_reg_device == "0" || $already_reg_device == "2"){
    if($is_external_request === true){
      $_add_log_message = $device_name."(".$_SERVER['REMOTE_ADDR'].")";
      inputLog("WARNING", $_this_location."#".$send_device, $this_device_name, "K_MODIFY", $send_user."#", "CODE_DEVICES_025", $_add_log_message);
      echo "N";
    }else{
      $_add_log_message = $device_name."(".$_SERVER['REMOTE_ADDR'].")";
      inputLog("WARNING", $_this_location, $device_name, "K_MODIFY", $_this_user, "CODE_DEVICES_026", $_add_log_message);
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_024"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      unset($kvmDB,$kvmJson);
      echo $kvmJson->getJsonEncode();
    }
    exit();
  }

  $_add_log_message = "<b>".$device_name."(".$device_ip4.")</b>\n";
  //name는 내부에서만 변경함
  if($is_external_request === false){
    //장비 수정정보 비교
    $name_sql = "UPDATE devices_data SET name = '".$device_name."' WHERE seq = '".$device_seq."' ";
    $res_name = $kvmDB->setData($name_sql);
    $_add_log_message .= " * Device name : ".$current_name." → ".$device_name."\n";

    if($current_name != $device_name &&
       $current_ip4 == $device_ip4 &&
       $current_subnet == $device_subnet4 &&
       $current_gateway == $device_gateway4 &&
       $current_webport == $device_webport &&
       $current_dns1 == $device_dns1 &&
       $current_dns2 == $device_dns2
    ){
      if($res_name){
        inputLog("INFO", $_this_location, $current_name, $_this_action, $_this_user, "CODE_DEVICES_027", $_add_log_message);
        $kvmJson->setJsonDataSingle(true);
        header("Content-type:application/json; charset=utf-8");
        $_SESSION["device_name"] = $device_name;
        exit($kvmJson->getJsonEncode());
      }else{
        inputLog("ERROR", $_this_location, $current_name, $_this_action, $_this_user, "CODE_DEVICES_028", "");
        $kvmJson->setJsonData("fieldName", "");
        $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_028"));
        $kvmJson->setJsonData("statusType", "error");
        header("HTTP/1.0 500 Menual Error");
        unset($kvmDB,$kvmJson);
        exit($kvmJson->getJsonEncode());
      }
    }
  }

  $sql = "UPDATE devices_data SET ip6 = '".$device_ip6."', subnet6 = '".$device_subnet6."', gateway6 = '".$device_gateway6."'";

/* ******************************
 * 로컬장비 수정
 *
 ****************************** */
if($is_local == 'Y'){

  // INI 쓰기 ****************************************
  //네트워크 설정파일
  $_network_setting = false;
  if($current_ip4 != $device_ip4){
    $_add_log_message .= " * Device IP : ".$current_ip4." → ".$device_ip4."\n";
    $sql .= ", ip4 = '".$device_ip4."'";
    $_SESSION["device_ip"] = $device_ip4;
    $_network_setting = true;
  }
  if($current_subnet != $device_subnet4){
    $_add_log_message .= " * Subnet Mask : ".$current_subnet." → ".$device_subnet4."\n";
    $sql .= ", subnet4 = '".$device_subnet4."'";
    $_network_setting = true;
  }
  if($current_gateway != $device_gateway4){
    $_add_log_message .= " * Default Gateway : ".$current_gateway." → ".$device_gateway4."\n";
    $sql .= ", gateway4 = '".$device_gateway4."'";
    $_network_setting = true;
  }
  if($_network_setting === true){
    if(is_file($_network_config_file)){
      $ini = new INIManager($_network_config_file);
      if($ini->Initialize()){
        $arrGet = $ini->getINIData();
        $arrData = array(
          "DEVICE"=>$arrGet["DEVICE"], "IPADDR"=>$device_ip4,
          "NETMASK"=>$device_subnet4, "GATEWAY"=>$device_gateway4,
          "ONBOOT"=>$arrGet["ONBOOT"]== 1?"yes":"no"
        );
        $ini->setINIData($arrData);
        $ini->writeINI();
      }
      unset($ini);
    }else{
      #error 네트워크설정파일 오류
      inputLog("ERROR", $_this_location, $device_name, "K_MODIFY", $_this_user, "CODE_DEVICES_030", "");
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_030"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }
  }

  //httpd설정파일
  if($current_webport != $device_webport){
    if(is_file($_httpd_config_file)){
      exec("sed -i '/server.port/s/[0-9]*$/".$device_webport."/g' ".$_httpd_config_file);
      $_add_log_message .= " * Web port : ".$current_webport." → ".$device_webport."\n";
      $sql .= ", web_port = '".$device_webport."'";
    }else{
      #error 웹서버설정파일 오류
      inputLog("ERROR", $_this_location, $device_name, $_this_action, $_this_user, "CODE_DEVICES_031", "");
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_031"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      unset($kvmDB,$kvmJson);
      exit($kvmJson->getJsonEncode());
    }
  }

  //DNS설정파일
  $_dns_setting = false;
  if($current_dns1 != $device_dns1){
    $current_dns1_ = ($current_dns1 == "") ? "none" : $current_dns1;
    $device_dns1_ = ($device_dns1 == "") ? "none" : $device_dns1;
    $_add_log_message .= " * Primary DNS : ".$current_dns1_." → ".$device_dns1_."\n";
    $sql .= ", dns1 = '".$device_dns1."'";
    $_dns_setting = true;
  }
  if($current_dns2 != $device_dns2){
    $current_dns2_ = ($current_dns2 == "") ? "none" : $current_dns2;
    $device_dns2_ = ($device_dns2 == "") ? "none" : $device_dns2;
    $_add_log_message .= " * Secondary DNS : ".$current_dns2_." → ".$device_dns2_."\n";
    $sql .= ", dns2 = '".$device_dns2."'";
    $_dns_setting = true;
  }
  if($_dns_setting === true){
    if(is_file($_dns_server_file)){
      $dns_data="";
      if($device_dns1){
        $dns_data="nameserver ".$device_dns1;
        if($device_dns2) $dns_data = $dns_data."\rnameserver ".$device_dns2;
      }
      file_put_contents($_dns_server_file, $dns_data);
    }else{
      #error DNS설정파일 오류
      inputLog("ERROR", $_this_location, $device_name, $_this_action, $_this_user, "CODE_DEVICES_032", "");
      $kvmJson->setJsonData("fieldName", "");
      $kvmJson->setJsonData("statusText", msg("ALERT_DEVICES_032"));
      $kvmJson->setJsonData("statusType", "error");
      header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }
  }
  // **********************************************************



  $ex_device_sql = "SELECT seq,ip4,web_port,name FROM devices_data WHERE local = 'N' AND active = 'Y'";
  //if($send_device != "") $external_device_sql .= " AND seq <> '".$send_device."' ";
  $rs = $kvmDB->getData($ex_device_sql);
  $is_ex_device = $kvmDB->getDataSingle($ex_device_sql);
  $result_json_data = "";
  $_add_log_message .= "[#change_devices#]";


  //보낼 디바이스가 있으면 보낸다.
  if($is_ex_device != ""){
    $curl_data = "&ip4=".$device_ip4."&ip6=".$device_ip6.
                 "&subnet4=".$device_subnet4."&subnet6=".$device_subnet6.
                 "&gateway4=".$device_gateway4."&gateway6=".$device_gateway6.
                 "&web_port=".$device_webport.
                 "&dns1=".$device_dns1."&dns2=".$device_dns2.
                 "&seq=".$device_seq."&send_device=".$send_device."&send_user=".$send_user;
    $curl = new CURL();
    $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_POST => true,
      CURLOPT_CONNECTTIMEOUT => 5,
      CURLOPT_POSTFIELDS => $curl_data
    );
    $rs = $kvmDB->getData($ex_device_sql);

    $result_array = array();
    $j = 0;
    while($row = $rs->fetchArray()){
      $curl->addSession("http://".$row['ip4'].":".$row['web_port']."/devices/update.php", $curl_opts);
      $result_array[$j] = array("name" => $row['name'],"seq" => $row['seq'],"ip" => $row['ip4']);
      $j++;
    }
    $curl_result = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);

    //결과값 분석하여 배열로 만들기
    for($i=0;$i<$j;$i++){
      $state = ($curl_result[$i] == "Y") ? true : false;
      //$result_array[$i]['state'] = $state;
      $kvmJson->setJsonData("seq", $result_array[$i]['seq']);
      $kvmJson->setJsonData("name", $result_array[$i]['name']);
      $kvmJson->setJsonData("state", $state);
      $result_json_data .= $kvmJson->getJsonEncode().",";
      if($state == true) $state_t = "1";
      else $state_t = "0";

      $_add_log_message .= " * ".$result_array[$i]['name']."(".$result_array[$i]['ip'].") - [#success_".$state_t."#] \n";
    }
    unset($result_array,$curl_result,$i,$j);
  }

  //내 DB에 쓰기 *************************************************
  $sql .= " WHERE seq = '".$device_seq."' ";
  $res = $kvmDB->setData($sql);
  $kvmJson->setJsonData("seq", $this_device_seq);
  $kvmJson->setJsonData("name", $this_device_name);

  //결과 돌려줌
  if($res){
    $kvmJson->setJsonData("state", true);
    $_add_log_message .= " * ".$this_device_name."(".$this_device_ip4.") - [#success_1#] \n";
    if($is_external_request === false){
      #내부요청
      inputLog("INFO", $_this_location, $device_name, $_this_action, $_this_user, "CODE_DEVICES_033", $_add_log_message);
    }
    else{
      #장비 수정 성공 : 외부요청
      inputLog("INFO", $_this_location."#".$send_device, $this_device_name, $_this_action, $send_user."#", "CODE_DEVICES_034", $_add_log_message);
    }
  }
  else{
     #장비 수정 실패 : 두부에러
     $kvmJson->setJsonData("state", false);
    $_add_log_message .= " * ".$this_device_name."(".$this_device_ip4.") - [#success_0#] \n";
    if($is_external_request === false){
      #내부요청
      inputLog("ERROR", $_this_location, $device_name, $_this_action, $_this_user, "CODE_DEVICES_035", $_add_log_message);
    }
    else{
      #외부요청
      inputLog("ERROR", $_this_location."#".$send_device, $this_device_name, $_this_action, $send_user."#", "CODE_DEVICES_036", $_add_log_message);
    }
  }
  $result_json_data .= $kvmJson->getJsonEncode();
  $result_json_data = "[".$result_json_data."]";
  //배열로 뿌려줌
  //header("Content-type:application/json; charset=utf-8");
  header("Content-type:text/javascript; charset=utf-8");
  echo $_GET["callback"]."(".$result_json_data.")";
  //execReboot(8);
}

/* ************************
 * 내장비에서 내장비 정보 수정 요청 응답
 *
 ************************ */ /*
#test code 101#########################################################
elseif($is_local != 'Y' && $is_external_request){

}

*/
/* ************************
 * 내장비에서 외부장비 정보 수정
 *
 ************************ */ /*
elseif($is_local != 'Y' && $is_external_request){
  $curl_data = "&ip4=".$device_ip4."&device_ip6=".$device_ip6.
               "&subnet4=".$device_subnet4."&subnet6=".$device_subnet6.
               "&gateway4=".$device_gateway4."&gateway6=".$device_gateway6.
               "&web_port=".$device_webport.
               "&dns1=".$device_dns1."&dns2=".$device_dns2.
               "&seq=".$device_seq."&send_device=".$this_device_seq;
  $curl = new CURL();
  $curl_opts = array(
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_POST => true,
    CURLOPT_POSTFIELDS => $curl_data
  );
  $curl->addSession("http://".$current_ip4.":".$current_webport."/devices/update.php", $curl_opts);
  $curl_result = $curl->exec();
  $curl->clear();
  unset($crul,$curl_opts);

  if($curl_result){
    #외부장비 수정 성공 :
    header("Content-type:application/json; charset=utf-8");
    exit($curl_result);

  }else{
    #장비 응답없음
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", "Target device do not response.");
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
    exit($kvmJson->getJsonEncode());
  }
}

#test code 101 CURL보내고 해당장비의 친구리스트 받아와 처리#########################################
elseif($is_local != 'Y' && $is_external_request){

}

*/

/* *******************************
 * 외부에서 장비 수정 요청
 *
 ******************************* */
else{
  //DB에 저장
  $sql .= ", ip4 = '".$device_ip4."', subnet4 = '".$device_subnet4."', gateway4 = '".$device_gateway4."',
             web_port = '".$device_webport."', dns1 = '".$device_dns1."', dns2 = '".$device_dns2."'  WHERE seq = '".$device_seq."' ";
  $res = $kvmDB->setData($sql);
  $_add_log_message = $device_name."(".$device_ip4.")";
  //결과 돌려줌
  if($res){
    if($send_device == $_local_device_seq){
      //이 장비에서 수정한것
      $send_user_seq = $kvmDB->getDataSingle("SELECT seq FROM users_data WHERE id='".$send_user."' AND active = 'Y'");
      inputLog("INFO", $_this_location, $device_name, $_this_action, $send_user_seq, "CODE_DEVICES_037", $_add_log_message);
    }else{
      //다른장비에서 요청한 다른장비의 정보
      inputLog("INFO", $_this_location."#".$send_device, $device_name, $_this_action, $send_user."#", "CODE_DEVICES_038", $_add_log_message);
    }
    echo "Y";
  }
  else{
    if($send_device == $_local_device_seq){
      //이 장비에서 수정한것
      $send_user_seq = $kvmDB->getDataSingle("SELECT seq FROM users_data WHERE id='".$send_user."' AND active = 'Y'");
      inputLog("ERROR", $_this_location, $device_name, $_this_action, $send_user_seq, "CODE_DEVICES_039", $_add_log_message);
    }else{
      //다른장비에서 요청한 다른장비의 정보
      inputLog("ERROR", $_this_location."#".$send_device, $device_name, $_this_action, $send_user."#", "CODE_DEVICES_040", $_add_log_message);
    }
    echo "N";
  }
}

unset($kvmDB,$kvmJson);
?>