<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

//리퍼러 검사
$referer = isset($_SERVER['HTTP_REFERER']) ? parse_url($_SERVER['HTTP_REFERER']) : false;
if(is_array($referer) == false || $referer['host'] != $_SERVER['HTTP_HOST']){
  exit("invalid referer");
}

//세션이 없으면 오류
if(empty($_SESSION['user_type']) || empty($_SESSION['user_seq'])){
  if(isset($_REQUEST['ext']) && $_REQUEST['ext'] == "Y" && $referer['port'] == "443"){
    $_is_ext_req = true;
    $_this_user = $_REQUEST['send_user']."#";
    $_this_location = "#".$_REQUEST['send_device'];
  }else{
    exit("no session");
  }
}else{
  $_is_ext_req = false;
  $_this_user = $_SESSION['user_seq'];
  $_this_location = "";
}

if(isset($_REQUEST['action']) && $_REQUEST['action'] != "" && isset($_REQUEST['target']) && $_REQUEST['target'] != ""){

  $_recive_action = $_REQUEST['action'];
  $_recive_target = $_REQUEST['target'];
  $_recive_file = isset($_REQUEST['file']) ? $_REQUEST['file'] : false;

  $kvmDB = new kvmDB();
  $get_device_info = $kvmDB->getData("SELECT name,local,ip4,web_port FROM devices_data WHERE seq = '".$_recive_target."'");
  if($row = $get_device_info->fetchArray()){
    $_target = $row['name'];
    $_device_local = $row['local'];
    $_device_ip = $row['ip4'];
    $_device_port = $row['web_port'];
  }
  unset($kvmDB,$row);

  $_add_log_message = " * ";
  $_add_log_message .= ($_is_ext_req === false) ? $_target."(".$_device_ip.") " : "";
  switch($_recive_action){
    case "remote":
      $_this_location = "L_SCREENS".$_this_location;
      if($_device_local == 'N'){
        $_code = "CODE_SCREENS_001";
      }else{
        $_code = "CODE_SCREENS_002";
        $_add_log_message = "";
      }
      $_kind = "K_REMOTE";
    break;

    case "download":
      $_this_location = "L_RECORDS".$_this_location;
      $_code = ($_is_ext_req === false) ? "CODE_RECORDS_006" : "CODE_RECORDS_007";
      $_kind = "K_DOWNLOAD";
      if($_recive_file !== false){
        $_add_log_message .= $_recive_file;
      }
      else
        $_add_log_message = "";
    break;

    case "play":
      $_this_location = "L_RECORDS".$_this_location;
      $_code = ($_is_ext_req === false) ? "CODE_RECORDS_004" : "CODE_RECORDS_005";
      $_kind = "K_PLAY";
      if($_recive_file !== false){
        $_add_log_message .= $_recive_file;
      }
      else
        $_add_log_message = "";
    break;

    default:
      exit("invalid action");
    break;
  }

  inputLog("INFO", $_this_location, $_target, $_kind, $_this_user, $_code, $_add_log_message);
  if($_device_local == "N" && $_is_ext_req === false){
    $send_data = "";
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';

    $curl = new CURL();
    $curl_opts = array(
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_POST => true,
        CURLOPT_CONNECTTIMEOUT => 3,
        CURLOPT_REFERER => "http://".$_device_ip.":443",
        CURLOPT_POSTFIELDS => "ext=Y&action=".$_recive_action."&target=".$_recive_target."&file=".$_recive_file."&send_user=".$_SESSION['user_id']."&send_device=".$_local_device_seq
    );
    $curl->addSession("http://".$_device_ip.":".$_device_port."/logs/add.php", $curl_opts);
    $curl_result = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);
  }
}else{
  exit("parameters are missing");
}
?>