<?php
/* ************************* *
* record file delete
*
* ************************** */
error_reporting(E_ERROR);
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';
$kvmJson = new kvmJson();

$_this_location = "L_RECORDS";
$_this_user = $_SESSION['user_seq'];

if(!isset($_SESSION['user_type']) || ($_SESSION['user_type'] != 'admin' && $_SESSION['user_type'] != 'super') || isset($_GET["callback"])){
  #권한없음
  $kvmJson->setJsonData("fieldName", "");
  $kvmJson->setJsonData("statusText", msg("ALERT_RECORDS_000"));
  $kvmJson->setJsonData("statusType", "error");
  header("HTTP/1.0 500 Menual Error");
  unset($kvmDB,$kvmJson);
  exit($kvmJson->getJsonEncode());
}

$dir_list = array();
$delete_ok = true;

if(isset($_REQUEST['file_name'])){
  $file_name = explode("_",str_replace(".ts","",$_REQUEST['file_name']));
  $record_dir = $_SERVER['DOCUMENT_ROOT']."/files/record/".$file_name[0]."/".$file_name[1];
  $_add_log_message = " * ".$_REQUEST['file_name']."\n";
}
elseif(isset($_REQUEST['file_date'])){

}
else{
  #파일입력 없음
  $kvmJson->setJsonData("fieldName", "");
  $kvmJson->setJsonData("statusText", msg("ALERT_RECORDS_003"));
  $kvmJson->setJsonData("statusType", "error");
  header("HTTP/1.0 500 Menual Error");
  unset($kvmDB,$kvmJson);
  exit($kvmJson->getJsonEncode());
}

if(is_dir($record_dir)){
  array_map("unlink", glob($record_dir."/*"));
  if(rmdir($record_dir)){
    #성공
    inputLog("INFO", $_this_location, $_local_device_name, "K_DELETE", $_this_user, "CODE_RECORDS_001", $_add_log_message);
    $kvmJson->setJsonDataSingle(true);
    header("Content-type:application/json; charset=utf-8");
  }else{
    #삭제오류
    inputLog("ERROR", $_this_location, "", "K_DELETE", $_this_user, "CODE_RECORDS_002", $_add_log_message);
    $kvmJson->setJsonData("fieldName", "");
    $kvmJson->setJsonData("statusText", msg("ALERT_RECORDS_002"));
    $kvmJson->setJsonData("statusType", "error");
    header("HTTP/1.0 500 Menual Error");
  }
}else{
  #삭제실패: 파일 없음
  inputLog("ERROR", $_this_location, "", "K_DELETE", $_this_user, "CODE_RECORDS_003", $_add_log_message);
  $kvmJson->setJsonData("fieldName", "");
  $kvmJson->setJsonData("statusText", msg("ALERT_RECORDS_003"));
  $kvmJson->setJsonData("statusType", "error");
  header("HTTP/1.0 500 Menual Error");
}


if($delete_ok == true){

}else{

}
echo $kvmJson->getJsonEncode();
unset($kvmDB,$kvmJson);

?>