<?php
  $_this_target = "LOCATION#L_SETTINGS_DATABASE";
  if(!defined("_KVM_SETTING")){
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
    $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
    inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
  }

  $html_pre = '<html><head><meta charset="utf-8" /></head><body><script type="text/javascript">';
  $html_tail = '</script></body></html>';
  if(isset($_REQUEST['action'])){
    if($_REQUEST['action'] == 'upload'){
      $file_name = $_FILES["database"]["name"];
      $temp_db = $_SERVER['DOCUMENT_ROOT']."/files/database/rskvm.temp";
      $db_success = false;
      $db_warn = false;
      $db_error = false;
      if(move_uploaded_file($_FILES["database"]["tmp_name"], $temp_db)){

        $certifyDBok = certifyDB($temp_db);
        if($certifyDBok !== false){
          if(copy($temp_db,$_db_path_settings)){
            $kvmDB = new kvmDB();
            $sql = "DELETE FROM devices_data WHERE local = 'N'";
            $user_map_sql = "DELETE FROM user_device_map";
            $kvmDB->setData($sql);
            $kvmDB->setData($user_map_sql);
            $db_success = true;
            echo $html_pre.'parent.callback(true, true); parent.location.replace("/signout/?log=none");'.$html_tail;
          }else{
            $db_error = true;
            echo $html_pre.'parent.callback({"statusText":"'.msg('ALERT_SETTING_006').'"},false);'.$html_tail;
          }
        }else{
          $db_warn = true;
          echo $html_pre.'parent.callback({"statusText":"'.msg('ALERT_SETTING_019').'","errorMessage":"'.$certifyDBok.'"},false);'.$html_tail;
        }

        unlink($temp_db);
      }
      else{
        $db_error = true;
        echo $html_pre.'parent.callback({"statusText":"'.msg('ALERT_SETTING_006').'"},false);'.$html_tail;
      }
      if($db_success === true) inputLog("INFO", $_this_location, $_this_target, "K_RESTORE", $_this_user, "CODE_SETTING_006", " * ".$file_name);
      if($db_warn === true) inputLog("WARNING", $_this_location, $_this_target, "K_RESTORE", $_this_user, "CODE_SETTING_019", "");
      if($db_error === true) inputLog("ERROR", $_this_location, $_this_target, "K_RESTORE", $_this_user, "CODE_SETTING_007", "");
      exit();
    }elseif($_REQUEST['action'] == 'download'){

      if(is_file($_db_path_settings)){
        $backup_name = "kvmDB-".date('ymd-His').".DB3";
        inputLog("INFO", $_this_location, $_this_target, "K_BACKUP", $_this_user, "CODE_SETTING_008", " * ".$backup_name);
        header("Content-Type: application/octet-stream");
        header("Content-Disposition: attachment; filename=$backup_name");
        header("Content-type:file/DB3");
        header("Content-Description: PHP5 Generated Data");
        header("Content-Transfer-Encoding: binary");
        header("Content-Length: ".filesize($_db_path_settings));
        header("Cache-Control: cache, must-reval!idate");
        header("Pragma: no-cache");
        header("Expires: 0");

        $fp = fopen($_db_path_settings, "rb");
        if(!fpassthru($fp)){
          fclose($fp);
          clearstatcache();
        }
      }else{
        echo '<script type="text/javascript"> parent.callback({"statusText":"'.msg('ALERT_SETTING_020').'","statusType":""}); </script>';
      }
      exit();
    }
  }
?>
  <fieldset>
    <legend><?=msg('SETTINGS_401')?></legend>
    <p><?=msg('SETTINGS_402')?></p>
    <label class="filename" title="Select Device"><?=msg('SETTINGS_403')?></label>
    <a href="#downloadFile" class="file download"><?=msg('SETTINGS_404')?></a>
  </fieldset>

  <fieldset class="last">
    <legend><?=msg('SETTINGS_405')?></legend>
    <p><?=msg('SETTINGS_406')?></p>

    <label class="filename" title="Select Device"><?=msg('SETTINGS_407')?></label>
    <span class="file_wrap">
      <input type="file" name="database" />
      <span class="file_button" title="<?=msg('SETTINGS_408')?>"><?=msg('SETTINGS_408')?></span>
    </span>

  </fieldset>
