<?php
$_this_target = "LOCATION#L_SETTINGS_RVIEW";
if(!defined("_KVM_SETTING")){
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
  $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
  inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
  exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
}

$is_rv_reg = false;
//$is_rv_login = $kvmDB->getDataSingle("SELECT rview_login FROM preference") == 'N' ? false : true;
$is_rv_setting_error = false;

//rview 연동 여부 체크
$_init_rview_setting_file = $_init_dir.'rview.init';

try{
  if(!is_file($_rview_setting_file))
    if(!is_file($_init_rview_setting_file) || !copy($_init_rview_setting_file,$_rview_setting_file))
      throw new Exception('ini file not exist.');

  $rviewIniData = parse_ini_file($_rview_setting_file,true,INI_SCANNER_RAW);
  $rviewAgentData = $rviewIniData['Agent'];

  if(!isset($rviewAgentData['GUID']) || $rviewAgentData['GUID'] == ''){
    $is_rv_reg = false;
  }else{

    //등록 확인
    require_once $_SERVER['DOCUMENT_ROOT'].'/_rview/_common.php';
    $rview_data['GUID'] = $rviewAgentData['GUID'];
    $rview_data['RVAV'] = '5';
    $rview_data['RSVFlag'] = '50';
    getResponse('login');
    $set_rview_ini_data = array(
      'RSVFlag' => '50'
    );
    setRviewINI($set_rview_ini_data);

    if($rview_data['RESULT'] > 100){
      $is_rv_reg = false;
      $set_rview_ini_data = array(
        'GUID' => ''
      );
      setRviewINI($set_rview_ini_data);
    }else{
      $is_rv_reg = true;
      $set_rview_ini_data = array(
        'AccountChangePage' => $rview_data['ACCOUNTCHANGE_PAGE'],
      //'AgentHelpPage' => $rview_data[''],
        'ConfigModifyPage' => $rview_data['CONFIGMODIFY_PAGE'],
        'ConfigQueryPage' => $rview_data['CONFIGQUERY_PAGE'],
      //'DistributeOkPage' => $rview_data[''],
      //'DistributeOkPage' => $rview_data[''],
      //'HWPage' => $rview_data[''],
      //'LogonPage' => $rview_data[''],
        'LogoutPage' => $rview_data['LOGOUT_PAGE'],
        'RmtcallConnectPage' => $rview_data['RMTCALLCONNECT_PAGE'],
        'RmtcallDisconnectPage' => $rview_data['RMTCALLDISCONNECT_PAGE'],
        'RmtftpConnectPage' => $rview_data['RMTFTPCONNECT_PAGE'],
        'RmtftpDisconnectPage' => $rview_data['RMTFTPDISCONNECT_PAGE'],
      //'RmtvpnConnectPage' => $rview_data[''],
      //'RmtvpnDisconnectPage' => $rview_data[''],
      //'SWPage' => $rview_data[''],
        'SessionResultPage' => $rview_data['SESSIONRESULT_PAGE'],
        'UpdateCheckPage' => $rview_data['UPDATECHECK_PAGE'],
        'UpdateServer' => $rview_data['UPDATEADDR'],
      //'UpdateServerPort' => $rview_data['UPDATEPORT'],
        'UpdateServerDir' => $rview_data['UPDATEDIR']
      );
      //setRviewINI($set_rview_ini_data);
    }

  }
}
catch(Exception $e){
  $is_rv_setting_error = true;
  exit($e->getMessage());
}

if($is_rv_setting_error){
?>

<?
  exit();
}

if(!$is_rv_reg){  //RVIEW AGENT AUTH ----------------------------------------------------------------
?>

<fieldset class="last">
  <legend><?=msg('RVIEW_101')?></legend>
  <p><?=msg('RVIEW_102')?><br></p>
  <a href="#rviewSetup" class="button"><?=msg('RVIEW_103')?></a>
</fieldset>

<?php
}else {
  //if($is_rv_login){  //RVIEW AGENT SETTING --------------------------------------------------------
?>

<?php //RVIEW AGENT LOGIN ----------------------------------------------------------------------------
  //}else{
?>

<fieldset>
  <legend><?=msg('RVIEW_104')?></legend>
  <p><?=msg('RVIEW_105')?><br></p>
  <a href="#rviewAccountChange" class="button run"><?=msg('RVIEW_106')?></a>
</fieldset>

<fieldset>
  <legend><?=msg('RVIEW_107')?></legend>
  <p><?=msg('RVIEW_108')?></p>
  <a href="#rviewDelete" class="button run"><?=msg('RVIEW_109')?></a>
</fieldset>


<?php
  //}
}
//DIALOGS --------------------------------------------------------------------------------------------
?>
<div id="rview-dialog-forms">

  <!-- agent setup -->
  <div id="rview-setup-usercheck" class="rview-dialog" data-step="setupUsercheck">
    <h3><?=msg('RVIEW_201')?></h3>
    <p><?=msg('RVIEW_202')?></p>
    <fieldset>
      <label><?=msg('RVIEW_203')?></label>
      <p class="input-wrap">
        <label class="wrap-label"><input type="radio" id="rview-product-type-biz" name="rviewAuthType" value="biz" /><?=msg('RVIEW_204')?></label>
        <label class="wrap-label"><input type="radio" id="rview-product-type-asp" name="rviewAuthType" value="asp" /><?=msg('RVIEW_205')?></label>
      </p>

      <label for="rvipt-serveraddr"><?=msg('RVIEW_206')?></label>
      <input type="text" id="rvipt-serveraddr" data-name="rvdata-SERVERADDR" class="text disabled" />

      <label for="rvipt-domain"><?=msg('RVIEW_207')?></label>
      <input type="text" id="rvipt-domain" data-name="rvdata-DOMAIN" class="text" />

      <label for="rvipt-regwebid"><?=msg('RVIEW_208')?></label>
      <input type="text" id="rvipt-regwebid" data-name="rvdata-WEBID" class="text" />

      <label for="rvipt-regwebpass"><?=msg('RVIEW_209')?></label>
      <input type="password" id="rvipt-regwebpass" data-name="rvdata-WEBPASS" class="text" />
    </fieldset>
    <div class="buttons">
      <button type="button" class="button btn-rview-cancel"><?=msg('BTN_CANCEL')?></button>
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_NEXT')?></button>
    </div>
  </div>
  <!-- agent reg -->
  <div id="rview-setup-agent" class="rview-dialog" data-step="setupAgent">
    <h3><?=msg('RVIEW_210')?></h3>
    <p><?=msg('RVIEW_211')?></p>
    <fieldset>
      <label for="rvipt-accessid"><?=msg('RVIEW_212')?></label>
      <input type="text" id="rvipt-accessid" data-name="rvdata-ACCESSID" class="text" />

      <label for="rvipt-accesspaw"><?=msg('RVIEW_213')?></label>
      <input type="password" id="rvipt-accesspaw" data-name="rvdata-ACCESSPWD" class="text" />

      <label for="rvipt-accesspawc"><?=msg('RVIEW_214')?></label>
      <input type="password" id="rvipt-accesspawc" data-name="rvdata-ACCESSPWD2" class="text" />
    </fieldset>
    <div class="buttons">
      <button type="button" class="button btn-rview-cancel"><?=msg('BTN_CANCEL')?></button>
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_NEXT')?></button>
    </div>
  </div>

  <div id="rview-setup-complete" class="rview-dialog" data-step="setupComplete">
    <h3><?=msg('RVIEW_215')?></h3>
    <p><?=msg('RVIEW_216')?></p>
    <fieldset>

    </fieldset>
    <div class="buttons">
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_FINISH')?></button>
    </div>
  </div>


  <!-- agent unset -->
  <div id="rview-delete-agent" class="rview-dialog" data-step="deleteAgent">
    <h3><?=msg('RVIEW_217')?></h3>
    <p><?=msg('RVIEW_218')?></p>
    <fieldset>
      <label for="rvipt-delwebid"><?=msg('RVIEW_208')?></label>
      <input type="text" id="rvipt-delwebid" data-name="rvdata-WEBID" class="text" />

      <label for="rvipt-delwebpw"><?=msg('RVIEW_209')?></label>
      <input type="password" id="rvipt-delwebpw" data-name="rvdata-WEBPASS" class="text" />
    </fieldset>
    <div class="buttons">
      <button type="button" class="button btn-rview-cancel"><?=msg('BTN_CANCEL')?></button>
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_NEXT')?></button>
    </div>
  </div>


  <div id="rview-delete-complete" class="rview-dialog" data-step="deleteComplete">
    <h3><?=msg('RVIEW_219')?></h3>
    <p><?=msg('RVIEW_220')?></p>
    <fieldset>

    </fieldset>
    <div class="buttons">
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_FINISH')?></button>
    </div>
  </div>

  <!-- update agent account -->
  <div id="rview-account-change" class="rview-dialog" data-step="accountChange">
    <h3><?=msg('RVIEW_221')?></h3>
    <p><?=msg('RVIEW_222')?></p>
    <fieldset>
      <label for="rvipt-updoldaccessid"><?=msg('RVIEW_223')?></label>
      <input type="text" id="rvipt-updoldaccessid" data-name="rvdata-OLDACCESSID" class="text" />

      <label for="rvipt-updoldaccesspw"><?=msg('RVIEW_224')?></label>
      <input type="password" id="rvipt-updoldaccesspw" data-name="rvdata-OLDACCESSPWD" class="text" />

      <label for="rvipt-updnewaccessid"><?=msg('RVIEW_225')?></label>
      <input type="text" id="rvipt-updnewaccessid" data-name="rvdata-NEWACCESSID" class="text" />

      <label for="rvipt-updnewaccesspw"><?=msg('RVIEW_226')?></label>
      <input type="password" id="rvipt-updnewaccesspw" data-name="rvdata-NEWACCESSPWD" class="text" />

      <label for="rvipt-updnewaccesspwc"><?=msg('RVIEW_227')?></label>
      <input type="password" id="rvipt-updnewaccesspwc" data-name="rvdata-NEWACCESSPWD2" class="text" />

    </fieldset>
    <div class="buttons">
      <button type="button" class="button btn-rview-cancel"><?=msg('BTN_CANCEL')?></button>
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_NEXT')?></button>
    </div>
  </div>

  <div id="rview-account-change-complete" class="rview-dialog" data-step="accountChangeComplete">
    <h3><?=msg('RVIEW_228')?></h3>
    <p><?=msg('RVIEW_229')?></p>
    <fieldset>

    </fieldset>
    <div class="buttons">
      <button type="button" class="button blue btn-rview-next"><?=msg('BTN_FINISH')?></button>
    </div>
  </div>
</div>