<?
  require_once $_SERVER['DOCUMENT_ROOT'].'/setup/_common.php';

  $is_error = false;
/* *************************
 * 파일체크
 ************************* */

  if($action == "check"){

    //네트워크 설정파일 검사
    $network_init = false;
    if(is_file($_network_config_file)){
      $ini = new INIManager($_network_config_file);
      if(!$ini->Initialize(true)){
        $network_init = true;
      }else{
        $arrGet = $ini->getINIData();
        if(isset($arrGet['DEVICE']) == false || $arrGet['DEVICE'] != 'eth0' || isset($arrGet['IPADDR']) == false || isset($arrGet['NETMASK']) == false || isset($arrGet['GATEWAY']) == false || isset($arrGet['ONBOOT']) == false){
          $network_init = true;
        }
      }
      unset($ini);

    }else{
      $network_init = true;
    }
    if($network_init === true){
      //초기화 파일 복사
      if(!copy($_init_network_config_file,$_network_config_file)) $is_error = true;
    }

    //DNS설정파일 검사
    $dns_init = false;
    if(is_file($_dns_server_file)){
      $dns_data = file_get_contents($_dns_server_file);
      if(!preg_match("/nameserver [\d]{1,3}.[\d]{1,3}.[\d]{1,3}.[\d]{1,3}/", $dns_data)){
        $dns_init = true;
      }
      $dns_init = true;
    }else{
      $dns_init = true;
    }
    if($dns_init === true){
      //초기화 파일 복사
      if(!copy($_init_dns_config_file,$_dns_server_file))$is_error = true;
    }

    //httpd파일 검사
    if(is_file($_httpd_config_file)){

    }else{
      $is_error = true;
    }

  }

/* *************************
 * 파일에 설정값 쓰기
 ************************* */

  elseif($action == "apply"){
    if($device_ip == "" || $device_subnet == "" || $device_gateway == "" || $device_port == ""){
      $is_error = true;
    }

    //네트워크 설정파일 적용
    if(is_file($_network_config_file)){
      $ini = new INIManager($_network_config_file);
      if($ini->Initialize()){
        $arrGet = $ini->getINIData();
        if(!isset($arrGet["DEVICE"])) $arrGet["DEVICE"] = "eth0";
        $arrData = array(
          "DEVICE"=>$arrGet["DEVICE"], "IPADDR"=>$device_ip,
          "NETMASK"=>$device_subnet, "GATEWAY"=>$device_gateway,
          "ONBOOT"=>$arrGet["ONBOOT"] == 1?"yes":"no"
        );
        $ini->setINIData($arrData);
        $ini->writeINI();
      }else{
        $is_error = true;
      }
      unset($ini);

    }else{
      $is_error = true;
    }

    //DNS파일 적용
    if(is_file($_dns_server_file)){
      $dns_data="";
      if($device_dns1){
        $dns_data="nameserver ".$device_dns1;
        if($device_dns2) $dns_data = $dns_data."\nnameserver ".$device_dns2;
      }
      file_put_contents($_dns_server_file, $dns_data);
    }else{
      $is_error = true;
    }

    //httpd포트 적용
    if(is_file($_httpd_config_file)){
      exec("sed -i '/server.port/s/[0-9]*$/".$device_port."/g' ".$_httpd_config_file);
    }else{
      $is_error = true;
    }

  }else{
    $is_error = true;
  }

  if($is_error === true){
    header("HTTP/1.0 500 Menual Error");
    echo "false";
  }
?>