<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

$admin_seq = $_SESSION["user_seq"];

$kvmDB = new kvmDB();
$users = $kvmDB->getData("SELECT seq, id FROM users_data");
$devices = $kvmDB->getData("SELECT seq, name FROM devices_data WHERE local <> 'Y'");

//해당유저정보
$user = $kvmDB->getData("SELECT seq, id, type FROM users_data WHERE seq = '".$admin_seq."'");
$user_devices = $kvmDB->getData("SELECT di.seq, di.name
                                 FROM devices_data di, user_device_map dm
                                 WHERE di.seq = dm.device AND dm.user = '".$admin_seq."' AND local = 'N'");
//디바이스이름
$local_device_name = $_SESSION["device_name"];
$row = $user->fetchArray();
?>
<div id="center"></div>
<div id="right" class="wide">

  <form action="/users/update.php" method="post" class="main" id="users">
    <input type="hidden" name="seq" value="<?=$row['seq']?>"/>

    <h2 class="caption"><?=msg('USERS_101')?></h2>
    <p><?=msg('USERS_102')?></p>

    <label><?=msg('USERS_103')?> <strong>*</strong></label>
    <input name="id_temp" value="<?=$row['id']?>" type="text" disabled="disabled" />
    <input name="id" value="<?=$row['id']?>" type="hidden" />
    <p class="hint"><?=msg('USERS_104')?></p>

    <label><?=msg('USERS_105')?></label>
    <input name="pw" type="password">
    <p class="hint"><?=msg('USERS_106')?></p>

    <label><?=msg('USERS_107')?></label>
    <input name="pw2" type="password">

    <input type="hidden" name="type" value="user" />

    <div id="assigned" style="padding-bottom: 40px;">
      <h2><?=msg('USERS_119')?></h2>
      <p><?=msg('USERS_120')?></p>
      <ul class="access-devices">
        <li class="fixed item"><?=$local_device_name?></li>
<?php
      while($row_d = $user_devices->fetchArray()){
        echo '<li class="item">'.$row_d['name'].'<input type="hidden" name="device_seq[]" value="'.$row_d['seq'].'"/></li>';
      }
?>
      </ul>
    </div>

    <div class="buttons">
      <input type="submit" class="button save dim" value="<?=msg('BTN_SAVE')?>" />
    </div>
  </form>
</div>

<?php
unset($kvmDB);
?>